Index: orxonox/branches/openAL/src/orxonox.cc
===================================================================
--- orxonox/branches/openAL/src/orxonox.cc	(revision 3921)
+++ orxonox/branches/openAL/src/orxonox.cc	(revision 4194)
@@ -22,19 +22,25 @@
    main-programmer: Patrick Boenzli
    co-programmer: Christian Meyer
-   co-programmer: Benjamin Grauer: injected ResourceManager/GraphicsEngine
+   co-programmer: Benjamin Grauer: injected ResourceManager/GraphicsEngine/GUI
 */
 
 #include "orxonox.h"
+
+#include "gui.h"
 
 #include "world.h"
 #include "data_tank.h"
 #include "command_node.h"
+#include "ini_parser.h"
 #include "game_loader.h"
 #include "graphics_engine.h"
 #include "resource_manager.h"
 #include "text_engine.h"
+#include "factory.h"
+#include "benchmark.h"
 
 #include <string.h>
-int verbose = 3;
+
+int verbose = 4;
 
 using namespace std;
@@ -42,8 +48,17 @@
 /**
    \brief create a new Orxonox
+
+   In this funcitons only global values are set. The game will not be started here.
 */
 Orxonox::Orxonox ()
 {
-  pause = false;
+  this->pause = false;
+
+  this->world = NULL;
+  this->resources = NULL;
+  this->localinput = NULL;
+
+  this->argc = 0;
+  this->argv = NULL;
 }
 
@@ -53,7 +68,8 @@
 Orxonox::~Orxonox () 
 {
+  int i =0;
   Orxonox::singletonRef = NULL;
   if( world != NULL) delete world;
-  if( localinput != NULL) delete world;
+  if( localinput != NULL) delete localinput;
   if( resources != NULL) delete resources;
   delete GraphicsEngine::getInstance(); // deleting the Graphics
@@ -84,5 +100,5 @@
 void Orxonox::getConfigFile (int argc, char** argv)
 {
-  strcpy (configfilename, "orxonox.conf");
+  strcpy (configfilename, "~/.orxonox/orxonox.conf");
 }
 
@@ -92,4 +108,6 @@
 int Orxonox::init (int argc, char** argv)
 {
+  this->argc = argc;
+  this->argv = argv;
   // parse command line
   // config file
@@ -98,4 +116,7 @@
   SDL_Init (SDL_INIT_TIMER);
   // initialize everything
+  printf("> Initializing resources\n");
+  if( initResources () == -1) return -1;
+
   if( initVideo() == -1) return -1;
   if( initSound() == -1) return -1;
@@ -104,6 +125,4 @@
   printf("> Initializing networking\n");
   if( initNetworking () == -1) return -1;
-  printf("> Initializing resources\n");
-  if( initResources () == -1) return -1;
   //printf("> Initializing world\n");
   //if( init_world () == -1) return -1; PB: world will be initialized when started
@@ -120,5 +139,5 @@
   
   GraphicsEngine::getInstance();
-  
+    
   return 0;
 }
@@ -143,5 +162,5 @@
 {
   // create localinput
-  localinput = new CommandNode( configfilename);
+  localinput = new CommandNode(configfilename);
   
   return 0;
@@ -164,11 +183,50 @@
 int Orxonox::initResources() 
 {
-  //  printf("Not yet implemented\n");
   PRINT(3)("initializing ResourceManager\n");
   resourceManager = ResourceManager::getInstance();
-  resourceManager->setDataDir("../data/");
-  return 0;
+
+  // create parser
+  IniParser parser (DEFAULT_CONFIG_FILE);
+  if( parser.getSection (CONFIG_SECTION_DATA) == -1)
+    {
+      PRINTF(1)("Could not find Section %s in %s\n", CONFIG_SECTION_DATA, DEFAULT_CONFIG_FILE);
+      return -1;
+    }
+  char namebuf[256];
+  char valuebuf[256];
+  memset (namebuf, 0, 256);
+  memset (valuebuf, 0, 256);
+  
+  while( parser.nextVar (namebuf, valuebuf) != -1)
+    {
+      if (!strcmp(namebuf, CONFIG_NAME_DATADIR))
+	{
+	  //  printf("Not yet implemented\n");
+	  if (!resourceManager->setDataDir(valuebuf))
+	    {
+	      PRINTF(1)("Data Could not be located\n");
+	      exit(-1);
+	    }
+	}
+      
+      memset (namebuf, 0, 256);
+      memset (valuebuf, 0, 256);
+    }
+  
+  if (!resourceManager->checkDataDir(DEFAULT_DATA_DIR_CHECKFILE))
+    {
+      PRINTF(1)("The DataDirectory %s could not be verified\nPlease Change in File %s Section %s Entry %s to a suitable value\n",
+		resourceManager->getDataDir(),
+		DEFAULT_CONFIG_FILE,
+		CONFIG_SECTION_DATA,
+		CONFIG_NAME_DATADIR);
+      exit(-1);
+    }
+
+
   PRINT(3)("initializing TextEngine\n");
   TextEngine::getInstance();
+
+  return 0;
 }
 
@@ -200,5 +258,6 @@
   
   this->gameLoader = GameLoader::getInstance();
-  this->gameLoader->loadDebugCampaign(DEBUG_CAMPAIGN_0);
+  this->gameLoader->loadCampaign("worlds/DefaultCampaign.oxc");
+  //  this->gameLoader->loadDebugCampaign(DEBUG_CAMPAIGN_0);
   this->gameLoader->init();
   this->gameLoader->start();
@@ -279,4 +338,5 @@
 
 
+bool showGui = false;
 
 /**
@@ -286,25 +346,16 @@
 */
 int main(int argc, char** argv) 
-{  
-  
-  /* reading arguments 
-     
-     currently supported arguments are:
-     <no args>                   ::    just starts orxonox
-     --benchmark                 ::    start the benchmark without starting orxonox
-     
-     this is a preselection: it matches to one of the start* functions, the
-     finetuning is made in those functions.
-  */
-
-
+{ 
+
+  // here the pre-arguments are loaded, these are needed to go either to orxonx itself, Help, or Benchmark.
   int i;
-  for(i = 0; i < argc; ++i)
-    {
-      if(! strcmp( "--help", argv[i])) return startHelp();
-      else if(! strcmp( "--benchmark", argv[i])) return startBenchmarks();
-    }
-
-  PRINTF(2)("Orxonox does not understand the arguments");
+  for(i = 1; i < argc; ++i)
+    {
+      if(! strcmp( "--help", argv[i]) || !strcmp("-h", argv[i])) return startHelp(argc, argv);
+      else if(!strcmp( "--benchmark", argv[i]) || !strcmp("-b", argv[i])) return startBenchmarks();
+      else if(!strcmp( "--gui", argv[i]) || !strcmp("-g", argv[i])) showGui = true;
+      //      else PRINTF(2)("Orxonox does not understand the arguments %s\n", argv[i]);
+    }
+
   return startOrxonox(argc, argv);
 }
@@ -312,11 +363,16 @@
 
 
-int startHelp()
-{
-  printf("orxonox: starts the orxonox game - rules\n");
-  printf("usage: orxonox [arg]\n\n");
-  printf("valid options:\n");
-  printf(" --benchmark\tstarts the orxonox benchmark\n");
-  printf(" --help \tshows this menu\n");
+int startHelp(int argc, char** argv)
+{
+  PRINT(0)("orxonox: starts the orxonox game - rules\n");
+  PRINT(0)("usage: orxonox [arg [arg...]]\n\n");
+  PRINT(0)("valid options:\n");
+  {
+    Gui* gui = new Gui(argc, argv);
+    gui->printHelp();
+    delete gui;
+  }
+  PRINT(0)(" -b|--benchmark:\t\tstarts the orxonox benchmark\n");
+  PRINT(0)(" -h|--help:\t\t\tshows this help\n");
 }
 
@@ -324,10 +380,31 @@
 int startOrxonox(int argc, char** argv)
 {
-  printf(">>> Starting Orxonox <<<\n");
+  // checking for existence of the configuration-files
+  if (showGui ||
+      !ResourceManager::isFile("~/.orxonox/orxonox.conf") ||
+      ResourceManager::isFile("~/.orxonox/orxonox.lock"))
+    {
+      if (ResourceManager::isFile("~/.orxonox/orxonox.lock"))
+	ResourceManager::deleteFile("~/.orxonox/orxonox.lock");
+      
+      // starting the GUI
+      Gui* gui = new Gui(argc, argv);
+      gui->startGui();
+
+      if (! gui->startOrxonox)
+	return 0;
+      
+      delete gui;
+    }
+  
+  PRINT(0)(">>> Starting Orxonox <<<\n");
+
+  ResourceManager::touchFile("~/.orxonox/orxonox.lock");
+
   Orxonox *orx = Orxonox::getInstance();
   
   if((*orx).init(argc, argv) == -1)
     {
-      printf("! Orxonox initialization failed\n");
+      PRINTF(1)("! Orxonox initialization failed\n");
       return -1;
     }
@@ -336,447 +413,5 @@
   
   delete orx;
-  
-}
-
-#if defined __linux__ 
-
-#include "list.h"
-#include "world_entity.h"
-#include "vector.h"
-#include "player.h"
-#include "base_object.h"
-#include <asm/msr.h>
-#include <linux/timex.h>
-
-
-#define LIST_MAX 1000
-#define VECTOR_MAX 1000000
-#define ITERATIONS 10000
-
-
-int startBenchmarks()
-{
-
-  printf("===========================================================\n");
-  printf("=                      BENCHMARKS                         =\n");
-  printf("===========================================================\n");
-  printf(" the author is not paying any attention to cacheing effects\n");
-  printf(" of the CPU.\n\n");
-  printf("[title]\t\t\t\t\t     [cycles]\t[loops]\n\n");
-  //  printf("------------------------------------------------------------\n\n");
-
-  // first measure the time overhead:
-  unsigned long ini, end, dt, tmp;
-  rdtscl(ini); rdtscl(end);
-  dt = end - ini;
-
-  int type = -1; 
-  /* type   -1 == all 
-     type    0 == framework
-     type    1 == vector
-     type    2 == quaternion
-     type    3 == lists
-  */
-  if(type == 0 || type == -1)
-    {
-      /* framework test*/
-      
-      printf("Generating Objects:\t\t\t\t\t%i\n", ITERATIONS);
-      /* ************WorldEntity class test************** */
-      WorldEntity* w = NULL;
-      int i = 0;
-      unsigned long mittel = 0;
-      
-      for(i = 0; i < ITERATIONS; ++i)
-	{
-	  rdtscl(ini);
-	  
-	  WorldEntity* w = new WorldEntity();
-	  
-	  rdtscl(end);
-	  delete w;
-	  mittel += (end - ini - dt);
-	}
-      float mi = mittel / (float)ITERATIONS;
-      printf(" Generate a WorldEntity object:\t\t%11.2f\n", mi);
-      
-      /*
-	mittel = 0;
-	for(i = 0; i < ITERATIONS; ++i)
-	{
-	rdtscl(ini);
-	
-	WorldEntity* w = new Primitive(P_SPHERE);
-	
-	rdtscl(end);
-	delete w;
-	mittel += (end - ini - dt);
-	}
-	mi = mittel / (float)ITERATIONS;
-	printf(" Generate a Primitive  object:\t\t%11.2f\n", mi);
-      */
-
-      mittel = 0;
-      for(i = 0; i < ITERATIONS; ++i)
-	{
-	  rdtscl(ini);
-	  
-	  Vector* v = new Vector();
-	  
-	  rdtscl(end);
-	  delete v;
-	  mittel += (end - ini - dt);
-	}
-      mi = mittel / (float)ITERATIONS;
-      printf(" Generate a Vector object:\t\t%11.2f\n", mi);
-
-
-     mittel = 0;
-      for(i = 0; i < ITERATIONS; ++i)
-	{
-	  rdtscl(ini);
-	  
-	  Quaternion* q = new Quaternion();
-	  
-	  rdtscl(end);
-	  delete q;
-	  mittel += (end - ini - dt);
-	}
-      mi = mittel / (float)ITERATIONS;
-      printf(" Generate a Quaternion object:\t\t%11.2f\n", mi);
-
-
-
-
-      printf("\nCalling function inline &| virtual, \t\t\t%i\n", ITERATIONS);
-      mittel = 0;
-      w = new WorldEntity();
-      for(i = 0; i < ITERATIONS; ++i)
-	{
-	  rdtscl(ini);
-	  
-	  w->tick(0.0f);
-
-	  rdtscl(end);
-	  mittel += (end - ini - dt);
-	  }
-      //delete w;
-      mi = mittel / (float)ITERATIONS;
-      printf(" Virt funct tick() of WE: \t\t%11.2f\n", mi);
-
-
-      mittel = 0;
-      WorldEntity wo;
-      for(i = 0; i < ITERATIONS; ++i)
-	{
-	  rdtscl(ini);
-	  
-	  wo.tick(0.0f);
-	   
-	  rdtscl(end);
-	  mittel += (end - ini - dt);
-	  }
-      //delete w;
-      mi = mittel / (float)ITERATIONS;
-      printf(" Inl virt funct tick() of WE v2: \t%11.2f\n", mi);
-
-      
-      mittel = 0;
-      BaseObject* bo = new BaseObject();
-      for(i = 0; i < ITERATIONS; ++i)
-	{
-	  rdtscl(ini);
-	  
-	  bo->isFinalized();
-	   
-	  rdtscl(end);
-	  mittel += (end - ini - dt);
-	  }
-      //delete w;
-      mi = mittel / (float)ITERATIONS;
-      printf(" Inl funct BaseObject::isFinazlized(): \t%11.2f\n", mi);
-
-      
-      tList<WorldEntity>* list = new tList<WorldEntity>();
-
-      
-      /* ************Primitvie class test************** */
-      list = new tList<WorldEntity>();
- 
-      
-      /*
-	mittel = 0;
-	w = new Primitive(P_SPHERE);
-	for(i = 0; i < ITERATIONS; ++i)
-	{
-	rdtscl(ini);
-	
-	w->tick(0.0f);
-	
-	rdtscl(end);
-	mittel += (end - ini - dt);
-	}
-	mi = mittel / (float)ITERATIONS;
-	printf(" Call function tick() of Prim:\t\t%11.2f\n", mi);
-      */
-      
-    }
-  
-  if(type == 1 || type == -1)
-    {
-      printf("\nDoing some simple vector operations: \t\t\t%i\n", VECTOR_MAX);
-      /* vector test */
-      Vector* a = new Vector(1.3, 5.3, 4.1);
-      Vector* b = new Vector(0.4, 2.5, 6.2);
-      Vector* c = new Vector();
-      
-      unsigned long mittel, ini, end;
-      float mi;
-      int i = 0;
-      // addition
-      mittel = 0;
-      for(i = 0; i < VECTOR_MAX; ++i)
-	{
-	  rdtscl(ini);
-	  
-	  *c = *a + *b;
-	   
-	  rdtscl(end);
-	  mittel += (end - ini - dt);
-	}
-      mi = mittel / (float)VECTOR_MAX;
-      printf(" Addition of two vectors:\t\t%11.2f\n", mi);
-      
-      // multiplikation
-
-      mittel = 0;
-      for(i = 0; i < VECTOR_MAX; ++i)
-	{
-	  rdtscl(ini);
-	  
-	  *c = a->cross( *b);
-	   
-	  rdtscl(end);
-	  mittel += (end - ini - dt);
-	}
-      mi = mittel / (float)VECTOR_MAX;
-      printf(" CrossMult of two vectors:\t\t%11.2f\n", mi);
-
-    }
-  if( type == 2 || type == -1)
-    {
-      /* quaternion test */
-      printf("\nDoing some simple quaternion operations: \t\t%i\n", VECTOR_MAX);
-      /* vector test */
-      Quaternion* a = new Quaternion();
-      Quaternion* b = new Quaternion();
-      Quaternion* c = new Quaternion();
-      
-      unsigned long mittel, ini, end;
-      float mi;
-      int i = 0;
-      // quaternion generieren mit spez konstruktor
-      mittel = 0;
-      Vector* qa = new Vector(4.6, 9.3, 0.4);
-      Vector* qb = new Vector(3.5, 6.1, 4.3);
-      for(i = 0; i < VECTOR_MAX; ++i)
-	{
-	  rdtscl(ini);
-	  
-	  Quaternion* qu = new Quaternion(*qa, *qb);
-	  
-	  rdtscl(end);
-	  delete qu;
-	  mittel += (end - ini - dt);
-	}
-      delete a;
-      delete b;
-      mi = mittel / (float)VECTOR_MAX;
-      printf(" Gen. quatern. betw. two vectors:\t%11.2f\n", mi);
-      
-      
-      // multiplication
-      mittel = 0;
-      for(i = 0; i < VECTOR_MAX; ++i)
-	{
-	  rdtscl(ini);
-	  
-	  *c = *a * *b;
-	  
-	  rdtscl(end);
-	  mittel += (end - ini - dt);
-	}
-      mi = mittel / (float)VECTOR_MAX;
-      printf(" Multiplying two quat.(=rot): a * b\t%11.2f\n", mi);
-      
-      
-      
-      // rotating a vector by a quaternion
-      mittel = 0;
-      for(i = 0; i < VECTOR_MAX; ++i)
-	{
-	  rdtscl(ini);
-	  
-	  *qa = a->apply(*qb);
-	  
-	  rdtscl(end);
-	  mittel += (end - ini - dt);
-	}
-      mi = mittel / (float)VECTOR_MAX;
-      printf(" Rot a vec by a quat: q->apply(v)\t%11.2f\n", mi);
-      
-      
-      
-      // generate rotation matrix
-      mittel = 0;
-      float matrix[4][4];
-      for(i = 0; i < VECTOR_MAX; ++i)
-	{
-	  rdtscl(ini);
-	  
-	  a->matrix(matrix);
-	  
-	  rdtscl(end);
-	  mittel += (end - ini - dt);
-	}
-      mi = mittel / (float)VECTOR_MAX;
-      printf(" Generate rot matrix: q->matrix(m)\t%11.2f\n", mi);
-    }
-  if( type == 3 || type == -1)
-    {
-      /* list tests*/
-      printf("\nList operations tests: \t\t\t\t\t%i\n", LIST_MAX);
-      tList<char>* list = new tList<char>();
-      char* name;
-      
-      printf(" Adding[1..10] elements to list, found:\n");
-      list->add("1");
-      list->add("2");
-      list->add("3");
-      list->add("4");
-      list->add("5");
-      list->add("6");
-      list->add("7");
-      list->add("8");
-      list->add("9");
-      list->add("10");
-      
-      /*give list out */
-      tIterator<char>* iterator = list->getIterator();
-      name = iterator->nextElement();
-      printf("  List Elements: \t\t");
-      while( name != NULL)
-	{
-	  printf("%s,", name);
-	  name = iterator->nextElement();
-	}
-      delete iterator;
-      printf("\n");
-      
-      
-      /*removing some elements from the list*/
-      printf(" Removing elements [2,3,6,8,10], adding [11] now found:\n");
-      list->remove("2");
-      list->remove("3");
-      list->remove("6");
-      list->remove("8");
-      list->remove("10");
-      list->add("11");
-      /*give list out */
-      iterator = list->getIterator();
-      name = iterator->nextElement();
-      printf("  List Elements: \t\t");
-      while( name != NULL)
-	{
-	  printf("%s,", name);
-	  name = iterator->nextElement();
-	}
-      delete iterator;
-      printf("\n");
-      
-      delete list;
-      printf("\nChecking list performance:\t\t\t\t%i\n", LIST_MAX);
-      
-      tList<int>* plist = new tList<int>();
-      unsigned long mittel, ini, end;
-      float mi;
-      int i = 0;
-      mittel = 0;
-      for(i = 0; i < LIST_MAX; ++i)
-	{
-	  rdtscl(ini);
-	  
-	  plist->add(&i);
-	  
-	  rdtscl(end);
-	  mittel += (end - ini - dt);
-	}
-      mi = mittel / (float)LIST_MAX;
-      printf(" Adding reference to list:\t\t%11.2f\n", mi);
-      
-      mittel = 0;
-      for(i = 0; i < LIST_MAX; ++i)
-	{
-	  rdtscl(ini);
-	  
-	  plist->remove(&i);
-	  
-	  rdtscl(end);
-	  mittel += (end - ini - dt);
-	}
-      mi = mittel / (float)LIST_MAX;
-      printf(" Removing 1st reference from list:\t%11.2f\n", mi);
-      
-
-      printf("\nList operations tests: \t\t\t\t\t%i\n", LIST_MAX);
-      list = new tList<char>();
-      printf(" Adding[1..10] elements to list, found:\n");
-      list->add("1");
-      list->add("2");
-      list->add("3");
-      list->add("4");
-      list->add("5");
-      list->add("6");
-      list->add("7");
-      list->add("8");
-      list->add("9");
-      list->add("10");
-      
-      /*give list out */
-      iterator = list->getIterator();
-      name = iterator->nextElement();
-      printf("  List Elements: \t\t");
-      while( name != NULL)
-	{
-	  printf("%s,", name);
-	  name = iterator->nextElement();
-	}
-      delete iterator;
-      printf("\n");
-      
-      
-      int c = 0;
-      printf(" Going trough list with nextElement(el) func: ");
-      name = list->firstElement();
-      while(c < 20)
-	{
-	  printf("%s,", name);
-	  name = list->nextElement(name);
-	  c++;
-	}
-      printf("\n");
-      
-
-      
-    }
-  
-}
-
-#else
-
-int startBenchmarks()
-{
-  PRINTF(1)("Benchmark is not implemented in this system\n");
-}
-
-#endif
+  ResourceManager::deleteFile("~/.orxonox/orxonox.lock");
+  
+}
Index: orxonox/branches/openAL/src/orxonox.h
===================================================================
--- orxonox/branches/openAL/src/orxonox.h	(revision 3921)
+++ orxonox/branches/openAL/src/orxonox.h	(revision 4194)
@@ -39,14 +39,10 @@
   Uint32 lastframe;           //!< Time of the last Frame
   
+  unsigned int argc;          //!< Count of Arguments of orxonox
+  char** argv;                //!< Values of th Arguments of orxonox.
+  
   void getConfigFile (int argc, char** argv);
   
-  // main loop functions
-  //  void synchronize ();
-  //void handle_input ();
-  //void time_slice ();
-  //void collision ();
-  //void display ();
-  
-  	// subsystem initialization
+  // subsystem initialization
   int initVideo ();
   int initSound ();
@@ -75,7 +71,6 @@
 };
 
-int startHelp(void);
+int startHelp(int argc, char** argv);
 int startOrxonox(int argc, char** argv);
-int startBenchmarks(void);
 
 #endif /* _ORXONOX_H */
Index: orxonox/branches/openAL/src/proto/proto_class.cc
===================================================================
--- orxonox/branches/openAL/src/proto/proto_class.cc	(revision 3921)
+++ orxonox/branches/openAL/src/proto/proto_class.cc	(revision 4194)
@@ -1,4 +1,2 @@
-
-
 /* 
    orxonox - the future of 3D-vertical-scrollers
@@ -16,9 +14,7 @@
 */
 
-#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_WORLD_ENTITY
+//#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_
 
 #include "proto_class.h"
-
-#include "stdincl.h" // maybe
 
 using namespace std;
@@ -43,11 +39,2 @@
   // delete what has to be deleted here
 }
-
-/**
-   \brief nonsense - delete this method
-   \param realy nothing to give
-   \returns true or false - probably nothing?
-
-   this is just to show the doxygen abilities (this for example is an extension for a long comment)
-*/
-bool ProtoClass::doNonSense (int nothing) {}
Index: orxonox/branches/openAL/src/proto/proto_class.h
===================================================================
--- orxonox/branches/openAL/src/proto/proto_class.h	(revision 3921)
+++ orxonox/branches/openAL/src/proto/proto_class.h	(revision 4194)
@@ -1,9 +1,6 @@
 /*! 
     \file proto_class.h
-    \brief Definition of the proto class template, used quickly start work
-    \todo Example: this shows how to use simply add a Marker that here has to be done something.
+    \brief Definition of ...
 
-    The Protoclass exists, to help you quikly getting the run for how to develop in orxonox.
-    It is an example for the CODING-CONVENTION, and a starting-point for every class.
 */
 
@@ -11,17 +8,11 @@
 #define _PROTO_CLASS_H
 
-#include "what realy has to be included"
 #include "base_object.h"
 
-// FORWARD DEFINITION \\
-class someClassWeNeed;
+// FORWARD DEFINITION
 
 
-/*class Test;*/ /* forward definition of class Test (without including it here!)*/
 
-//! A default class that aids you to start creating a new class
-/**
-   here can be some longer description of this class
-*/
+//! A class for ...
 class ProtoClass : public BaseObject {
 
@@ -30,8 +21,6 @@
   virtual ~ProtoClass();
 
-  bool doNonSense (int nothing);
 
  private:
-  int nonSense;  //!< doxygen tag here like this for all the variables - delete this variable if you use this
 
 };
Index: orxonox/branches/openAL/src/proto/proto_singleton.h
===================================================================
--- orxonox/branches/openAL/src/proto/proto_singleton.h	(revision 3921)
+++ orxonox/branches/openAL/src/proto/proto_singleton.h	(revision 4194)
@@ -1,7 +1,6 @@
 /*! 
     \file proto_singleton.h
-    \brief Definition of the proto class template, used quickly start work
+    \brief Definition of the ... singleton Class
     
-    a simple file to copy and create a singleton-class from
 */
 
@@ -11,5 +10,5 @@
 #include "base_object.h"
 
-// FORWARD DEFINITION \\
+// FORWARD DEFINITION
 
 //! A default singleton class.
Index: orxonox/branches/openAL/src/story_entities/campaign.cc
===================================================================
--- orxonox/branches/openAL/src/story_entities/campaign.cc	(revision 3921)
+++ orxonox/branches/openAL/src/story_entities/campaign.cc	(revision 4194)
@@ -19,4 +19,5 @@
 #include "campaign.h"
 
+#include "game_loader.h"
 #include "story_entity.h"
 
@@ -34,5 +35,58 @@
   this->isInit = false;
 }
-
+Campaign::Campaign ( TiXmlElement* root) 
+{
+  TiXmlElement* element;
+  const char* string;
+  int id;
+  
+  PRINTF(3)("Loading Campaign...\n");
+  
+  assert( root != NULL);
+  GameLoader* loader = GameLoader::getInstance();
+  
+  this->entities = new tList<StoryEntity>();
+  this->isInit = false;
+  
+  // grab all the necessary parameters
+  string = grabParameter( root, "identifier");
+  if( string == NULL || sscanf(string, "%d", &id) != 1)
+    {
+      PRINTF(2)("Campaign is missing a proper 'identifier'\n");
+      this->setStoryID( -1);
+    }
+  else this->setStoryID( id);
+  
+  // find WorldList
+  element = root->FirstChildElement( "WorldList");
+  if( element == NULL)
+    {
+      PRINTF(2)("Campaign is missing a proper 'WorldList'\n");
+    }
+  else
+    element = element->FirstChildElement();
+  
+  // load Worlds/Subcampaigns/Whatever
+  StoryEntity* lastCreated = NULL;
+  while( element != NULL)
+    {
+      printf("Campaign: Constructor: adding a world\n");
+      StoryEntity* created = (StoryEntity*) loader->fabricate( element);
+      /*
+      if( lastCreated != NULL) 
+	created->setNextStoryID( lastCreated->getStoryID());
+      else
+	created->setNextStoryID( WORLD_ID_GAMEEND);
+      */
+      if( created != NULL)
+	{
+	  this->addEntity( created);	
+	  lastCreated = created;
+	}
+      element = element->NextSiblingElement();
+    }
+  //if( lastCreated != NULL) 
+  //lastCreated->setStoryID( WORLD_ID_GAMEEND);
+}
 
 Campaign::~Campaign () {}
Index: orxonox/branches/openAL/src/story_entities/campaign.h
===================================================================
--- orxonox/branches/openAL/src/story_entities/campaign.h	(revision 3921)
+++ orxonox/branches/openAL/src/story_entities/campaign.h	(revision 4194)
@@ -14,4 +14,5 @@
  public:
   Campaign ();
+  Campaign ( TiXmlElement* root);
   virtual ~Campaign ();
 
